/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
)

// ProductTerm Description of a productTerm linked to this product. This represent a commitment with a duration
type ProductTerm struct {
	// Description of the productTerm
	Description *string `json:"description,omitempty"`
	// Name of the productTerm
	Name *string `json:"name,omitempty"`
	Duration *Quantity `json:"duration,omitempty"`
	ValidFor *TimePeriod `json:"validFor,omitempty"`
	// When sub-classing, this defines the super-class
	BaseType *string `json:"@baseType,omitempty"`
	// A URI to a JSON-Schema file that defines additional attributes and relationships
	SchemaLocation *string `json:"@schemaLocation,omitempty"`
	// When sub-classing, this defines the sub-class entity name
	Type *string `json:"@type,omitempty"`
}

// NewProductTerm instantiates a new ProductTerm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewProductTerm() *ProductTerm {
	this := ProductTerm{}
	return &this
}

// NewProductTermWithDefaults instantiates a new ProductTerm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewProductTermWithDefaults() *ProductTerm {
	this := ProductTerm{}
	return &this
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *ProductTerm) GetDescription() string {
	if o == nil || o.Description == nil {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductTerm) GetDescriptionOk() (*string, bool) {
	if o == nil || o.Description == nil {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *ProductTerm) HasDescription() bool {
	if o != nil && o.Description != nil {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *ProductTerm) SetDescription(v string) {
	o.Description = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *ProductTerm) GetName() string {
	if o == nil || o.Name == nil {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductTerm) GetNameOk() (*string, bool) {
	if o == nil || o.Name == nil {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *ProductTerm) HasName() bool {
	if o != nil && o.Name != nil {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *ProductTerm) SetName(v string) {
	o.Name = &v
}

// GetDuration returns the Duration field value if set, zero value otherwise.
func (o *ProductTerm) GetDuration() Quantity {
	if o == nil || o.Duration == nil {
		var ret Quantity
		return ret
	}
	return *o.Duration
}

// GetDurationOk returns a tuple with the Duration field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductTerm) GetDurationOk() (*Quantity, bool) {
	if o == nil || o.Duration == nil {
		return nil, false
	}
	return o.Duration, true
}

// HasDuration returns a boolean if a field has been set.
func (o *ProductTerm) HasDuration() bool {
	if o != nil && o.Duration != nil {
		return true
	}

	return false
}

// SetDuration gets a reference to the given Quantity and assigns it to the Duration field.
func (o *ProductTerm) SetDuration(v Quantity) {
	o.Duration = &v
}

// GetValidFor returns the ValidFor field value if set, zero value otherwise.
func (o *ProductTerm) GetValidFor() TimePeriod {
	if o == nil || o.ValidFor == nil {
		var ret TimePeriod
		return ret
	}
	return *o.ValidFor
}

// GetValidForOk returns a tuple with the ValidFor field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductTerm) GetValidForOk() (*TimePeriod, bool) {
	if o == nil || o.ValidFor == nil {
		return nil, false
	}
	return o.ValidFor, true
}

// HasValidFor returns a boolean if a field has been set.
func (o *ProductTerm) HasValidFor() bool {
	if o != nil && o.ValidFor != nil {
		return true
	}

	return false
}

// SetValidFor gets a reference to the given TimePeriod and assigns it to the ValidFor field.
func (o *ProductTerm) SetValidFor(v TimePeriod) {
	o.ValidFor = &v
}

// GetBaseType returns the BaseType field value if set, zero value otherwise.
func (o *ProductTerm) GetBaseType() string {
	if o == nil || o.BaseType == nil {
		var ret string
		return ret
	}
	return *o.BaseType
}

// GetBaseTypeOk returns a tuple with the BaseType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductTerm) GetBaseTypeOk() (*string, bool) {
	if o == nil || o.BaseType == nil {
		return nil, false
	}
	return o.BaseType, true
}

// HasBaseType returns a boolean if a field has been set.
func (o *ProductTerm) HasBaseType() bool {
	if o != nil && o.BaseType != nil {
		return true
	}

	return false
}

// SetBaseType gets a reference to the given string and assigns it to the BaseType field.
func (o *ProductTerm) SetBaseType(v string) {
	o.BaseType = &v
}

// GetSchemaLocation returns the SchemaLocation field value if set, zero value otherwise.
func (o *ProductTerm) GetSchemaLocation() string {
	if o == nil || o.SchemaLocation == nil {
		var ret string
		return ret
	}
	return *o.SchemaLocation
}

// GetSchemaLocationOk returns a tuple with the SchemaLocation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductTerm) GetSchemaLocationOk() (*string, bool) {
	if o == nil || o.SchemaLocation == nil {
		return nil, false
	}
	return o.SchemaLocation, true
}

// HasSchemaLocation returns a boolean if a field has been set.
func (o *ProductTerm) HasSchemaLocation() bool {
	if o != nil && o.SchemaLocation != nil {
		return true
	}

	return false
}

// SetSchemaLocation gets a reference to the given string and assigns it to the SchemaLocation field.
func (o *ProductTerm) SetSchemaLocation(v string) {
	o.SchemaLocation = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *ProductTerm) GetType() string {
	if o == nil || o.Type == nil {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductTerm) GetTypeOk() (*string, bool) {
	if o == nil || o.Type == nil {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *ProductTerm) HasType() bool {
	if o != nil && o.Type != nil {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *ProductTerm) SetType(v string) {
	o.Type = &v
}

func (o ProductTerm) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Description != nil {
		toSerialize["description"] = o.Description
	}
	if o.Name != nil {
		toSerialize["name"] = o.Name
	}
	if o.Duration != nil {
		toSerialize["duration"] = o.Duration
	}
	if o.ValidFor != nil {
		toSerialize["validFor"] = o.ValidFor
	}
	if o.BaseType != nil {
		toSerialize["@baseType"] = o.BaseType
	}
	if o.SchemaLocation != nil {
		toSerialize["@schemaLocation"] = o.SchemaLocation
	}
	if o.Type != nil {
		toSerialize["@type"] = o.Type
	}
	return json.Marshal(toSerialize)
}

type NullableProductTerm struct {
	value *ProductTerm
	isSet bool
}

func (v NullableProductTerm) Get() *ProductTerm {
	return v.value
}

func (v *NullableProductTerm) Set(val *ProductTerm) {
	v.value = val
	v.isSet = true
}

func (v NullableProductTerm) IsSet() bool {
	return v.isSet
}

func (v *NullableProductTerm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableProductTerm(val *ProductTerm) *NullableProductTerm {
	return &NullableProductTerm{value: val, isSet: true}
}

func (v NullableProductTerm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableProductTerm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


